--[[
    MrInfernal's Language Learner v1.0
        Spam each language until you learn it
        Teach: Use a maxxed language 100 times to teach group members

    Usage: /lua run milang [teach]
            Using teach will do 100 lines for maxed languages
]]

local mq = require('mq')
local stayOpen = true

print("\arMrInfernal's \ax Language Learner \aov1.0")
print('Spam each language until you learn it')
print('Teach: Use a maxxed language 100 times to teach group members\n')

if not mq.TLO.Group() then
    print('\arError\ax: You are not in a group! Closing!')
    stayOpen = false
end

-- Get list of languages known and skill
local myLangs = {}

local function getLangs(doAll)
    local langNum = 0
    for i = 1, 27 do
        local skill = mq.TLO.Me.LanguageSkill(i)()
        if skill > 0 then
            langNum = langNum +1
            if doAll then
                local prof = skill
                table.insert(myLangs, {lang = mq.TLO.Me.Language(i)(), skill = prof, num = langNum})
            elseif not doAll then
                if skill < 100 then
                    local prof = skill
                    table.insert(myLangs, {lang = mq.TLO.Me.Language(i)(), skill = prof, num = langNum})
                end
            end
        end
    end
end

-- On Firiona Vie, Common is replaced by Human Tongue, but the command requires Common
local function doLangs(args)
    local doAll = false
    if args ~= nil then
        if args:lower() == 'teach' then
            doAll = true
        end
    end

    getLangs(doAll)

    local langNum = 1
    for _, speak in ipairs(myLangs) do
        if speak.skill == 100 and doAll then
            mq.cmdf('/lang %d', speak.num)
            printf('[%d/%d] \ao%s \axis \at100\ax. Speak it 100 times.', langNum, #myLangs, speak.lang)
            langNum = langNum + 1
            for i = 1, 20 do
                mq.cmd('/gsay There once was a runner named Dwight,')
                mq.delay(250)
                mq.cmd('/gsay Who could speed even faster than light.')
                mq.delay(250)
                mq.cmd('/gsay He set out one day,')
                mq.delay(250)
                mq.cmd('/gsay In a relative way,')
                mq.delay(250)
                mq.cmd('/gsay And returned on the previous night.')
                mq.delay(250)
            end
        elseif speak.skill < 100 and speak.skill > 0 then
            printf('[%d/%d] \ao%s \axis \at%d\ax. Speaking until 100.', langNum, #myLangs, speak.lang, speak.skill)
            langNum = langNum + 1
            mq.cmdf('/lang %d', speak.num)
            for i = 1, 200 do
                mq.cmd('/gsay There once was a runner named Dwight,')
                mq.delay(250)
                mq.cmd('/gsay Who could speed even faster than light.')
                mq.delay(250)
                mq.cmd('/gsay He set out one day,')
                mq.delay(250)
                mq.cmd('/gsay In a relative way,')
                mq.delay(250)
                mq.cmd('/gsay And returned on the previous night.')
                mq.delay(250)
                if mq.TLO.Me.LanguageSkill(speak.lang)() == 100 then
                    printf('\ao%s \axis now \at100.', speak.lang)
                    break
                end
            end
        end
    end
    print('Language learning complete. Closing now.')
    stayOpen = false
end

local args = {...}
if #args == 1 then
    doLangs(args[1])
else
    doLangs()
end

while stayOpen do
    mq.doevents()
    mq.delay(1000)
end